import { AsyncAction } from "./AsyncAction";
export declare class TypedAsyncActionClassFactory<S> {
    AsyncAction: typeof AsyncAction;
    SimpleAsyncAction: {
        new <R = any>(payload: import("./SimpleAsyncAction").SimpleAsyncActionPayload<S, R>): {
            execute(dispatch: import("../types").DispatchTypedAction, getState: import("../types").StateGetter<S>): Promise<R>;
            readonly payload: import("./SimpleAsyncAction").SimpleAsyncActionPayload<S, R>;
            readonly type: string;
            toPlainObject(): import("./BaseTypedAction").ReducerActionArg;
        };
    };
    ParallelTasksAsyncAction: {
        new <R = any[]>(payload: import("./ParallelTasksAsyncAction").ParallelTasksPayload<S, R>): {
            execute(dispatch: import("../types").DispatchTypedAction, getState: import("../types").StateGetter<S>): Promise<R>;
            readonly payload: import("./ParallelTasksAsyncAction").ParallelTasksPayload<S, R>;
            readonly type: string;
            toPlainObject(): import("./BaseTypedAction").ReducerActionArg;
        };
    };
    SeriesTasksAsyncAction: {
        new <R = any[]>(payload: import("./SeriesTasksAsyncAction").SeriesTasksPayload<S, R>): {
            execute(dispatch: import("../types").DispatchTypedAction, getState: import("../types").StateGetter<S>): Promise<R>;
            readonly payload: import("./SeriesTasksAsyncAction").SeriesTasksPayload<S, R>;
            readonly type: string;
            toPlainObject(): import("./BaseTypedAction").ReducerActionArg;
        };
    };
    TimeoutAsyncAction: {
        new (payload: import("./TimeoutAsyncAction").TimeoutAsyncActionPayload<S>): {
            execute(dispatch: import("../types").DispatchTypedAction, getState: import("../types").StateGetter<S>): () => void;
            readonly payload: import("./TimeoutAsyncAction").TimeoutAsyncActionPayload<S>;
            readonly type: string;
            toPlainObject(): import("./BaseTypedAction").ReducerActionArg;
        };
    };
}
